﻿// Program 1A
// CIS 200-01
// Fall 2020
// Due: 9/21/2020
// By: Andrew L. Wright (students use Grading ID)
/*
   Grading ID: E5200
   Program Number: 4
   Due Date: 11/23/2020
   Course Section: CIS 200-76-4208
   Program Description: This program Sorts Parcel objects.
*/
// File: TestParcels.cs
// This is a simple, console application designed to exercise the Parcel hierarchy.
// It creates several different Parcels and prints them.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using static System.Console;

namespace Prog1
{
    class TestParcels
    {
        // Precondition:  None
        // Postcondition: Parcels have been created and displayed
        static void Main(string[] args)
        {
            // Test Data - Magic Numbers OK
            Address a1 = new Address("  John Smith  ", "   123 Any St.   ", "  Apt. 45 ",
                "  Louisville   ", "  KY   ", 40202);
            Address a2 = new Address("Jane Doe", "987 Main St.",
                "Beverly Hills", "CA", 90210);
            Address a3 = new Address("James Kirk", "654 Roddenberry Way", "Suite 321",
                "El Paso", "TX", 79901);
            Address a4 = new Address("John Crichton", "678 Pau Place", "Apt. 7",
                "Portland", "ME", 04101);
            Address a5 = new Address("Jane Doe", "643 Hartland Avenue",
                "Berlin", "WI", 54923);

            Letter letter1 = new Letter(a1, a2, 3.95M);
            GroundPackage gp1 = new GroundPackage(a3, a4, 14, 10, 5, 12.5);
            NextDayAirPackage ndap1 = new NextDayAirPackage(a4, a5, 25, 15, 15, 85, 7.50M);
            TwoDayAirPackage tdap1 = new TwoDayAirPackage(a4, a1, 46.5, 39.5, 28.0, 80.5, TwoDayAirPackage.Delivery.Saver);
            Letter letter2 = new Letter(a1, a3, .5M);
            Letter letter3 = new Letter(a2, a5, 500M);
            GroundPackage gp2 = new GroundPackage(a5, a1, 10, 10, 5, 9);
            GroundPackage gp3 = new GroundPackage(a3, a2, 14, 14, 5, 15);
            NextDayAirPackage ndap2 = new NextDayAirPackage(a3, a4, 23, 19, 15, 85, 9M);
            TwoDayAirPackage tdap2 = new TwoDayAirPackage(a5, a1, 45, 40, 28.0, 80.5, TwoDayAirPackage.Delivery.Early);

            List<Parcel> parcels;      // List of test parcels

            parcels = new List<Parcel>();

            parcels.Add(letter1); // Populate list
            parcels.Add(gp1);
            parcels.Add(ndap1);
            parcels.Add(tdap1);
            parcels.Add(letter2);
            parcels.Add(letter3);
            parcels.Add(gp2);
            parcels.Add(gp3);
            parcels.Add(ndap2);
            parcels.Add(tdap2);

            // Sort parcels by cost
            parcels.Sort();
            WriteLine("Sorted list by ascending cost:");
            WriteLine("");
            foreach (Parcel parcel in parcels)
                //WriteLine($"{parcel.CalcCost():C}");
                WriteLine($"Cost: {parcel.CalcCost():C} | {parcel.OriginAddress.Name} -> {parcel.DestinationAddress.Name}");
            Pause();

            // Sort parcels by descending destination zipcode
            parcels.Sort(new CompareByZipcodeDesc());
            WriteLine("Sorted list by descending destination zipcode:");
            WriteLine("");
            foreach (Parcel parcel in parcels)
                //WriteLine(parcel.DestinationAddress.Zip);
                WriteLine($"Zip: {parcel.DestinationAddress.Zip} | {parcel.OriginAddress.Name} -> {parcel.DestinationAddress.Name}");
            Pause();

            // Sort parcels by ascending parcel type & descending cost
            parcels.Sort(new CompareByParcelTypeAndCost());
            WriteLine("Sorted list by ascending parcel type & descending cost:");
            WriteLine("");
            foreach (Parcel parcel in parcels)
                WriteLine($"Type: {parcel.GetType().ToString()} | Cost: {parcel.CalcCost():C}");
            Pause();
        }

        // Precondition:  None
        // Postcondition: Pauses program execution until user presses Enter and
        //                then clears the screen
        public static void Pause()
        {
            WriteLine("Press Enter to Continue...");
            ReadLine();

            Console.Clear(); // Clear screen
        }
    }
}
